#ifndef CPP2BINh 
#define CPP2BINh
#include <stdio.h>
#include "DefList.h"
#include "Reader.h"
#include "Writer.h"

enum VarTypes
{
	VARTYPE_NONE	// an error if encountered
	,VARTYPE_CLASS
	,VARTYPE_STRING
	,VARTYPE_FLOAT
	,VARTYPE_INTEGER
	,VARTYPE_ARRAY
};

class Classes
{
public:
	Classes();
	~Classes();

	int		ProcessClass(bool start=false);
	int		Output(class Writer *);
	int		Type;
	char *	Name;
	char *	Value;

	Classes *next;
	Classes *embedded;
private:

	int		AddClass();
	int		AddVariable();
	int		AddArray(bool embed=false);
	int		AddValue(const char *tkn);
	int		OutputArray(class Writer *);
	Classes *NewClass();
	int		Count();
};

class DEPBODLL_API Cpp2BinClass
{
public:

	Cpp2BinClass();
	~Cpp2BinClass();

	int			ProcessFile(const char *filename);
	int			ProcessBuffer(const char *BufferName,const char *filename,unsigned sz);
	const char *ErrString(int code);
	int			GetReturnedToken();
	char *		GetReadToken(){return ::Read.Token;}
	int			Output(const char *filename);
// vp api
	Classes	*	FindClass(const char *cname);
private:
	int		Start(const char *fname);

	void	Clear();
	Classes *First;
};

extern DefList *DefList;

#endif