// DePbo.cpp : Defines the entry point for the DLL application.
//
// and, includes a visual basic api
//
#include "gpl.h"		// licence

#include "stdafx.h"
#include "DePbo.h"
#include <string.h>
#include <malloc.h>
#include <comdef.h>		// vb requiremnt
#include <oleauto.h>	// ditto

// use dumpbinGui to list the mangled names.
// they are directly meaningful to other C++ applications wanting to hook into
// this dll, but a plain vanilla non-mangled entry exist (for VB eg) in DepBpo.def
//

/*
The def file contains 'proper' names for access from VB
*/

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}

/////////////////////////////////////////////////////////////////
///////// Visual Basic API
/////////////////////////////////////////////////////////////////
/* we could get fancy here and assign a new instance only if accessed
  but, bugger it
*/

static class DEPBODLL_API pboContainer vbContainer;


#define VB_API	DEPBODLL_API __stdcall
// returns the filename of the entry (for writing eg) 
BSTR CommonString(const char *str)
{
	if (!str) str="";
	return 	SysAllocStringByteLen(str,strlen(str));
}


BSTR VB_API DePboGetVersion()
{
	return CommonString(vbContainer.Version);
}
// fairly standard and obvious open/close
//
// Internally, the dll cleans out any existing file (and it's memory)
// if it remained open prior to this call
//
int VB_API DePboOpen(const char *fname)
{
	return vbContainer.Open(fname);
	//
	// returns a negative value on a fail
}

void DEPBODLL_API DePboClose()
{
	vbContainer.Close();
}

// access the reason for any failure after any call, here

BSTR DEPBODLL_API DePboStrError()
{
const char *str=vbContainer.strError();
	return SysAllocStringByteLen(str,strlen(str));
}


int VB_API DePboFindEntry(char *fname) // returns a handle
{
	return (int)vbContainer.FindEntry(fname);
}

// returns either the lenght of the data (including zero) or -ve status

BSTR VB_API DePboGetData(int entry,int *status)
{
BSTR str=NULL;

	*status=vbContainer.GetData((pbo_entry*) entry); // returns length or status
	if (*status<0) return str;
	str= SysAllocStringByteLen((char *)vbContainer.GetDataPtr((pbo_entry *)entry),*status);
	vbContainer.FreeData((pbo_entry *) entry);
	return str;
}

int VB_API DePboFileCount()
{
	return (int)vbContainer.GetEntryCount();
}
int VB_API DePboGetNumberOfEntries()
{
	return vbContainer.GetEntryCount();
}
// return the 1st entry. and iterate
int VB_API DePboFirstEntry()
{
	return (int)vbContainer.FirstEntry;
}
int VB_API DePboNextEntry(int entry)
{
	return (int)vbContainer.GetNextEntry((pbo_entry *)entry);
}
int VB_API DePboWasEncrypted(int entry)
{
	return vbContainer.WasEncrypted((pbo_entry *)entry);
}
int VB_API DePboIsCompressed(int entry)
{
	return vbContainer.IsCompressed((pbo_entry *)entry);
}


BSTR VB_API DePboGetEntryName(int entry)
{
	return CommonString(vbContainer.GetEntryFilename((pbo_entry *)entry));
}
BSTR VB_API DePboGetProductExtension()
{
	return CommonString(vbContainer.Product.Extension);
}
BSTR VB_API DePboGetProductName()
{
	return CommonString(vbContainer.Product.Name);
}
BSTR VB_API DePboGetProductType()
{
	return CommonString(vbContainer.Product.Type);
}
////////////////////////////
////////// cpp2bin stuff
/////////////////////////////

int VB_API DePboScanText(char *text,char *fname) // returns a status
{
	return (int)vbContainer.cppbin.ProcessBuffer(text,fname,strlen(text));
}
BSTR VB_API DePboScanErrStr(int err)
{
const char *str=vbContainer.cppbin.ErrString(err);
	return SysAllocStringByteLen(str,strlen(str));
}
int VB_API DePboScanFindClass(char *text) // returns a handle
{
	return (int)vbContainer.cppbin.FindClass(text);
}

int VB_API DePboScanGetEmbeddedHandle(int handle) // returns a handle
{
	return (int)((Classes *)handle)->embedded;
}

int VB_API DePboScanGetNextHandle(int handle) // returns a handle
{
	return (int)((Classes *)handle)->next;
}
BSTR VB_API DePboScanGetName(int handle)
{
	return CommonString((char *)((Classes *)handle)->Name);
}
BSTR VB_API DePboScanGetValue(int handle)
{
	return CommonString((char *)((Classes *)handle)->Value);
}
int VB_API DePboScanGetType(int handle)
{
	return ((Classes *)handle)->Type;
}
