#include "gpl.h"
#include "stdafx.h"
#include "DePbo.h"
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
//#include "Reader.h"
#include "ErrTypes.h"
#include "PboUtils.h"

Defines::Defines(const char *str,const char *v)
{
	next=NULL;
	name=str;
	Value=v;
}
Defines::~Defines()
{
	if (name) free ((void*)name);
	if (Value) free((void *)Value);
	if (next) delete next;
}
DefList::DefList()
{
	ExpandedLine=NULL;
	Defines=NULL;
	Clear();
}

void DefList::Clear()
{
	if (Defines) delete Defines;
	if (ExpandedLine) free(ExpandedLine);
	Defines=NULL;
	ExpandedLine=NULL;
	DefCount=0;
	ExpandedLineLen=0;
}

//Gparms(1,$STRED102_CIVIL_DRIVER,	CESNAcoPILOT		);
//#define Gparms(sz,name,mdl) mapsize=sz;	DisplayName=name;	model=mdl


static void	FreeParms(char **Aparms,int Acount)
{
	if (!Aparms) return;
	for (int i=0;i<Acount;i++)	free(Aparms[i]);
	free(Aparms);
}
void DefList::FreeVparms()
{
	FreeParms(vparray,vpcount);
	vpcount=0;
	vparray=NULL;
}



bool DefList::allocVparm(char *v)
{
	Trim(v);

char **newvp=(char **)realloc(vparray,(vpcount+1)*sizeof(char **));
	if (newvp)
	{
		vparray=newvp;
		if ((vparray[vpcount++]=strdup(v))!=NULL) return true;
		vpcount--;
	}
	FreeVparms();
	return false;
}
bool DefList::ParseCommas(const char *ptr)
{
char val[1000];
char *valptr=val;

	vpcount=0;
	vparray=NULL;
	for (;;)
	{
		switch(*ptr)
		{
		case ',': 
			*valptr=0; ptr++; 
			if (!allocVparm(val)) 	return false;
			valptr=val;
			break;
		case ')': 
			*valptr=0;
			return allocVparm(val);

		default: *valptr++=*ptr++; break;
		}
	}
}

//Gparms(1,$STRED102_CIVIL_DRIVER,	CESNAcoPILOT		);
//#define Gparms(sz,name,mdl) mapsize=sz;	DisplayName=name;	model=mdl

int DefList::Find(const char *what1,const char **into)
{
struct Defines *def;
char *ptr1=strchr(what1,'(');

	if (!ptr1)
	{
		for (def=Defines;def;def=def->next)
		{
			if (!strcmp(what1,def->name)) 
			{
				*into=def->Value;
				return TOKEN_VALID;
			}
		}
		return TOKEN_EOF;
	}
	if (!strchr(ptr1,')')) return ERR_CLOSEPAR_EXPECTED;

char *what=strdup(what1);

	if (!what) return ERR_NO_MEMORY;
int sts;

	ptr1=strchr(what,'(');

	*ptr1++=0;
/*
	if (!ParseCommas(ptr1)) 
	{
		free(what);
		return ERR_NO_MEMORY;
	}
*/
bool trig=false;

	for (def=Defines;def;def=def->next)
	{
		if (!strcmp(what,def->name)) 
		{
			if (!ExpandedLine || ExpandedLineLen!=2*Read.RawLineLen)
			{
				if (!(ExpandedLine=(char *)malloc(ExpandedLineLen=2*Read.RawLineLen)))
					return ERR_NO_MEMORY;
			}

		char *outptr=ExpandedLine;// is no longer null at this point
		const char *inptr=def->Value;
		char vv[20],*aptr; int index;

// it's genuine so parse it
			if (!trig)
			{
				trig=true;
				if (!ParseCommas(ptr1)) 
				{
					free(what);
					return ERR_NO_MEMORY;
				}
			}

			while (*inptr)
			{
				if (*inptr!='#') *outptr++=*inptr++;
				else
				{
					inptr++;
					for (aptr=vv;*inptr!='#';)	*aptr++=*inptr++;
					*aptr=0;
					inptr++;
					index=atoi(vv);
					if (index>=vpcount) goto err10;
					aptr=vparray[index];
					while (*aptr) *outptr++=*aptr++;
				}
			}
			*outptr=0;
			*into=ExpandedLine;
			free(what);
			FreeVparms();
			return TOKEN_VALID;
		}
	}
//	sts=ERR_NO_DEFINE;
//	goto f2;
	// this because something = "House(Res)" is not a macro
	free(what);
	return TOKEN_EOF;

err10:
	sts=ERR_DEFINE_PARMCOUNT;
//f2:
	free(what);
	FreeVparms();
	return sts;
}

static const char *HuntNeedle(const char *Haystack,const char *needle)
{
const char *from=Haystack;
int len=strlen(needle);
const char *end;

	for(;;)
	{
		from=FindLead(from);
		if (!from) return NULL;
		end=FindEnd(from);
		if (!end)
		{
			if (!strcmp(from,needle)) return from;
			return NULL;
		}
		
		if (!strncmp(from,needle,end-from)) return from;
		from=end;
	}
}
// #define whatever ( 1, 3, 4 ) verbs.......

int DefList::Add(const char *label,const char *parms)
{
int i,sts;
struct Defines *def;
char *RawVal;
int Acount;
char **Aparms=NULL;
//			class Name##Dead: Name##Dying \
// #define FRED(Name)

// def label looks for special case of () which will allow , and whitespace
char *name=strdup(label);
	if (!name) return ERR_NO_MEMORY;
// if it's a parm type, grab each comma separated value
char *ptr=strchr(name,'('); // matching brace is garanteed
	if (ptr)
	{
		*ptr++=0;
		if (!strchr(ptr,')')) {free(name); return ERR_NO_PARMEND;}
		if (!ParseCommas(ptr)){free(name); return ERR_NO_MEMORY;};
		Aparms=vparray;
		Acount=vpcount;
		vpcount=0;
	}
// acount aparms now hold the values
	if (!(RawVal=strdup(parms)))
	{
		sts=	ERR_NO_MEMORY;
		goto freeUS;
	}
	Trim(RawVal);
//Gparms(1,$STRED102_CIVIL_DRIVER,	CESNAcoPILOT		);
//#define Gparms(sz,name,mdl) mapsize=sz;	DisplayName=name;	model=mdl
// replace parms with ###
	if (ptr)
	{
	char newval[10000];
	char zug[20];

		for (i=0;i<Acount;i++)
		{// haystack,needle
			char *from=RawVal;
			newval[0]=0;
			char *match=Aparms[i];
			int len=strlen(match);
			while ((ptr=(char *)HuntNeedle(from,match)))
			{
				strncat(newval,from,ptr-from);
				sprintf(zug,"#%d#",i);
				strcat(newval,zug);
				from=&ptr[len];
				if (*from=='#')
				{
					if (from[1]=='#') from+=2;
					else 
					{
						sts= ERR_HASH_DET;
						free(RawVal);
						goto freeUS;
					}
				}
			}
			strcat(newval,from);
			free(RawVal);
			if (!(RawVal=strdup(newval)))
			{
				sts=	ERR_NO_MEMORY;
				goto freeUS;
			}
		}
		FreeParms(Aparms,Acount);
	}

	def=new struct Defines(name,RawVal);
	
	if (!def) {	free(name);	free(RawVal); return ERR_NO_MEMORY; }

	if (!Defines) 
	{
		Defines=def;
		DefCount=1;
	}
	else
	{
		DefCount++;
		struct Defines *df;for (df=Defines;df->next;df=df->next) ;
		df->next=def;
	}
	return NO_ERROR;
freeUS:
	free(name);
	if (ptr)		FreeParms(Aparms,Acount);
	return sts;
}
/*
bool DefList::Output()
{

	if (!Write.Long(DefCount)) return false; 

struct Defines *def;

	for (def=Defines;def;def=def->next)
		if (!Write.Define(def->name,def->Type==VARTYPE_INTEGER?atoi(def->Value):0)) 
			return false;
	return true;
}
*/

