#include "gpl.h"
#include "stdafx.h"
#include "DePbo.h"
#include "Writer.h"
#include <stdlib.h>
#include <string.h>
/* this is a simple formatted series of write functions that organsie
the data the way ofp engine likes to read it.
*/


#define HEADER_SIZE 7
static char header[HEADER_SIZE]={0,'r','a','P',4,0,0};

bool Writer::Open(const char *fname)
{
	Close(); // just in case
	if (!(fpout=fopen(fname,"wb"))) return false;
	if (fwrite(header,1,HEADER_SIZE,fpout)==HEADER_SIZE) return true;
	Close();
	return false;
}
void Writer::Close()
{
	if (fpout)fclose(fpout);
	fpout=NULL;
	if (!StrNames) return;
	delete StrNames;
	StrNames=NULL;
}
StrNames::StrNames()
{
	name=NULL;
	next=NULL;
};
StrNames::~StrNames()
{
	if (name) free (name);
	if (next) delete next;
};
bool Writer::ClassName(Classes *cl,int children)
{
	if (fputc(PKT_CLASS,fpout)==EOF) return false;
	if (!IndexedString(cl->Name)) return false;
	if (!String(cl->Value)) return false; // if any
	return CodedInteger(children);
}
bool Writer::ArrayName(const char *ArrayName,int children)
{
	if (fputc(PKT_ARRAYS,fpout)==EOF) return false;
	if (!IndexedString(ArrayName)) return false; 
	return CodedInteger(children);
}
bool Writer::ArraySpecial(int children)
{
	if (fputc(VAR_ARRAY,fpout)==EOF) return false;
	// no name associated with embedded arrays
	return CodedInteger(children);
}


/////// Packet Type 1 Variables
bool Writer::Variable(Classes *cl)
{
	return CommonVariable(cl);
}

bool Writer::ArrayVariable(Classes *cl)
{
	return CommonVariable(cl,true);
}
bool Writer::CommonVariable(Classes *cl,bool array)
{
int v;

	switch(cl->Type)
	{
	default: return false;
	case VARTYPE_STRING: v=VAR_STRING; break;
	case VARTYPE_FLOAT:	v=VAR_FLOAT; break;
	case VARTYPE_INTEGER: v=VAR_INTEGER; break;
	}
	if (!array && fputc(PKT_VARIABLES,fpout)==EOF) return false;

	if (fputc(v,fpout)==EOF) return false;
	if (!array && !IndexedString(cl->Name)) return false; // can be blank

	switch(v)
	{
	case VAR_STRING:  return IndexedString(cl->Value);
	case VAR_INTEGER: return Long(atoi(cl->Value));
	case VAR_FLOAT:
	{
	float f=(float)atof(cl->Value);
		return fwrite(&f,1,4,fpout)==4;
	}
	}
	return false;
}

bool Writer::IndexedString(const char *str)
{
int i=0;
class StrNames *st=StrNames;

	for (;st;st=st->next,i++)
		if (!stricmp(st->name,str))	
			return CodedInteger(i);

class StrNames *newst=new class StrNames();

	if (!newst){ return false;}

	if (!(newst->name=strdup(str))) return false;

	if (!(st=StrNames)) StrNames=newst;
	else
	{

		while (st->next) st=st->next;
		st->next=newst;
	}

	if (!CodedInteger(i)) return false;
	return String(str);
}

bool Writer::String(const char *str)
{
	if (!fpout) return false;
	if (!str || !*str) return fputc(0,fpout)!=EOF;
unsigned len = strlen(str)+1;
	return fwrite(str,1,len,fpout)==len;
}
bool Writer::Define(const char *str,int value)
{
	if (!String(str)) return false;
	return Long(value);
}

bool Writer::Long(int val)
{
	if (!fpout) return false;
	return fwrite(&val,1,4,fpout)==4;
}
bool Writer::CodedInteger(int val)
{
/*int val GetByte()

 if (val & 0x80)
 {
 int extra= GetByte()
  val += (extra - 1) * 0x80;
 }
 return val;
80 = 80 1
81 = 81 1
FF = FF 1
100 = 80 + 2
101 = 81 + 2
180 = 80 + 3
1FF = FF + 3*/
	if (val<0x80)	return fputc(val,fpout)!=EOF;
	if (fputc(val|0x80,fpout)==EOF) return false;
	return fputc(val>>7,fpout)!=EOF;
}

