/*
 * Dos Prompt EXAMPLE CODE FOR USE WITH DEPBO.DLL
 *------------------------------------------------
 * Operation Flashpoint Binary to CPP converter.
 * Will convert a 'binarized' config.cpp or autosave.fps to a human readable format.
 *
 * Syntax: bin3cpp mission.sqm
 *
 *		sends text output to screen and <filename.txt>
 *		returns 0 on success
*/

#include "..\gpl.h"						// license agreement
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#define STAND_ALONE 0
#if !STAND_ALONE
#include "..\DePbo\DePbo.h"				// bring in the dll
#else
#define DEPBODLL_API
#include "..\DePbo\Bin2CppClass.h"
#endif

#if _DEBUG
#include <crtdbg.h>
#endif

int main(int argc, char *argv[])
{
#if _DEBUG
// Get current flag
int tmpFlag = _CrtSetDbgFlag( _CRTDBG_REPORT_FLAG );

// Turn on leak-checking bit
tmpFlag |= _CRTDBG_LEAK_CHECK_DF;

// Turn off CRT block checking bit
tmpFlag &= ~_CRTDBG_CHECK_CRT_DF;

// Set flag to the new value
_CrtSetDbgFlag( tmpFlag );

#endif


#if !STAND_ALONE
pboContainer PboDll;					// instance the dll
#else
	bincpp		bincpp;

#endif
char *ptr;

    if (argc < 2)
    {
		ptr=strrchr(argv[0],'\\');
		if (!ptr) ptr=argv[0]; 	else ptr++;

        printf("Syntax: %s mission.sqm (eg)\n", ptr);
        return 1;
    }

#if !STAND_ALONE
  
	if (!PboDll.OpenBinCpp(argv[1]))	// open mission.sqm eg
#else
	if (!bincpp.Open(argv[1]))
#endif
	{
		printf("oops\n");
		return 2;
	}

#if !STAND_ALONE
	ptr=PboDll.ReadBinCpp();			// decrypt it
#else
	ptr=bincpp.ReadPackets();
#endif

	printf("%s\n",ptr?ptr:"Bugger");	// print the extracted data, or fail
	if (ptr)
	{
	char outname[1000];
		sprintf(outname,"%s.txt",argv[1]);

		if (!PboDll.bincpp.Write(outname,ptr))
		{
			fprintf(stderr,"Cannot write to %s\n",outname);
		}
	}
#if !STAND_ALONE
	PboDll.CloseBinCpp();				// release internal buffers
#else
	bincpp.Close();
#endif
	printf("done\n");
	return ptr?0:3;
}
