/*
** example code of how to convert sqm files into binary
*/
#include "..\gpl.h"						// license agreement
#include "..\DePbo\DePbo.h"				// bring in the dll
#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <stdlib.h>
#include "cpp3bin.h"

// winpbo cannot handle
//		upper case PBO
//		/* comments */
//		name = value (no semicolon)

pboContainer PboDll;					// instance the dll

#if _DEBUG
#include <crtdbg.h>
#endif
int main(int argv, char *argc[])
{
#if _DEBUG
int tmpFlag = _CrtSetDbgFlag( _CRTDBG_REPORT_FLAG );// Get current flag
tmpFlag |= _CRTDBG_LEAK_CHECK_DF;// Turn on leak-checking bit
tmpFlag &= ~_CRTDBG_CHECK_CRT_DF;// Turn off CRT block checking bit
_CrtSetDbgFlag( tmpFlag );// Set flag to the new value
#endif

	if (argv!=2)
	{
	char *exename=strrchr(argc[0],'\\');
		if (exename) exename+=1;
		else exename=argc[0];
		printf("Syntax: %s <filename>\n",exename);
		return 1;
	}

char *sourcefile=argc[1];
char *ptr=strrchr(sourcefile,'.');

	if (ptr)
	{
		if (!stricmp(ptr,".bin"))
		{
			fprintf(stderr,"Impossible, source file cannot be a bin\n");
			return 1;
		}
	}

int len=strlen(sourcefile)+4+1; // assume no extension
char *destfile=(char *)malloc(len);

	if (!destfile)
	{
		fprintf(stderr,"no memory\n");
		return 2;
	}
	
	sprintf(destfile,"%s.bin",sourcefile);

// two simple commands to do the lot
	// read the file,
	// write the output

int sts;
#define USE_FILE 0

#if USE_FILE
	sts=PboDll.cppbin.ProcessFile(sourcefile);
#else
FILE	*fpin;
unsigned	FileCount;

	if ((fpin=fopen(sourcefile,"rb"))==NULL) return false;

	if (fseek(fpin,0,SEEK_END)) goto bad;
	FileCount=ftell(fpin);
	rewind(fpin);
	if (!(ptr=( char *)malloc(FileCount))) goto bad;
	if (fread(ptr,1,FileCount,fpin)!=FileCount) 
	{
		free(ptr);//Close();
bad:
		fclose(fpin);
		return false;
	}
	fclose(fpin);
	sts=PboDll.cppbin.ProcessBuffer(ptr,sourcefile,FileCount);
	free(ptr);
#endif

	if (!sts) 	sts=PboDll.cppbin.Output(destfile);

	free(destfile);
	if (sts) 
	{
		fprintf(stderr,"\nERROR: %s\n",PboDll.cppbin.ErrString(sts));
		return 6;
	}
	fprintf(stderr,"Done\n");
	return 0;
}
